<template>
  <theme-mobile-black-components-ui-announcement v-if="!announcement.IsHidden" :announcement="announcement.Text"
        />
  <div class="pb-[30px]">
    <utils-mobile-banner
      :theme-properties="themeProperties"
      :actived="'HomeInitial'"
    />
    <div
      class="deposit-promotion-container w-full flex bg-[var(--background3)]"
    >
      <span
        v-if="!authenticated && registerEnabled"
        :class="`lobby-quicklink relative h-[56px] flex justify-center items-center gap-2 ${
          promotionTabEnabled ? 'w-[50%]' : 'w-full'
        }`"
        @click="toggleAuthModal"
      >
        <svg-icon svg-name="joinnow-icon" class="icon w-[24px] h-[24px]" />
        <span>{{ $t("joinnow") }}</span>
      </span>
      <nuxt-link
        v-if="
          authenticated &&
          depositWithdrawEnabled &&
          isCashPlayer &&
          isShowDepositWithdrawal
        "
        to="/deposit"
        :class="`lobby-quicklink relative h-[56px] flex justify-center items-center gap-2 ${
          promotionTabEnabled ? 'w-[50%]' : 'w-full'
        }`"
      >
        <svg-icon svg-name="deposit-bank-icon" class="icon w-[24px] h-[24px]" />
        <span>{{ $t(`deposit${isBhinbhin}`) }}</span>
      </nuxt-link>
      <nuxt-link
        v-if="promotionTabEnabled && isCashPlayer"
        to="/promotion"
        :class="`lobby-quicklink relative h-[56px] flex justify-center items-center gap-2 lobby-promotion ${
          isShowPromotionFullWidth ? 'w-full' : 'w-[50%]'
        }`"
      >
        <svg-icon
          svg-name="promotion-reqular-icon"
          class="icon w-[24px] h-[24px]"
        />
        <span>{{ $t("promotion") }}</span>
      </nuxt-link>
    </div>
    <sport-m-popular-match v-if="isRecommendMatchEnabled" class="px-2" />
    <div
      class="lobby-list-container grid gap-2 p-2 grid-cols-2 auto-rows-[34vw] mb-[2.2rem]"
    >
      <tamplate v-for="menu in menuTabHeaders" :key="menu.TabType">
        <nuxt-link
          v-if="shouldDisplayMenuTab(menu.TabType)"
          :to="menu?.TabURL"
          class="lobby-entry w-full h-full"
        >
          <img :src="getMenuTabContent(menu.TabType).ImagePath" />
          <div class="lobby-entry-title">
            {{ $t(menu?.TabType.replace(" ", "_").toLowerCase()) }}
          </div>
        </nuxt-link>
      </tamplate>
    </div>
  </div>
</template>

<script lang="ts">
import { PropType, defineComponent, computed } from "vue";
import _ from "lodash";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";
import { useHeaderComponent } from "@/composables/useTheme";

export default defineComponent({
  name: "Home",
  setup() {
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const isRecommendMatchEnabled = computed(
      (): boolean =>
        !themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "sportsbook_recommend_matches"
        ).IsHidden
    );
    const registerEnabled = computed(
      (): boolean =>
        !themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "register"
        ).IsHidden
    );
    const depositWithdrawEnabled = computed(
      (): boolean =>
        !themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "deposit_withdraw"
        ).IsHidden
    );
    const promotionTabEnabled = computed(
      (): boolean =>
        !themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "promotion_tab"
        ).IsHidden
    );

    const { menuTabHeaders, isShowDepositWithdrawal, isCashPlayer } =
      useHeaderComponent();
    const authenticated = computed(() => store.state.auth);
    const announcement = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          store.state.companyThemePropertiesFromApi.ThemeProperties,
          "announcement"
        )
    );
    const getSingleThemeProperty = (key: string) =>
      themePropertyHelper.getSingleThemeProperty(themeProperties.value, key);
    const isPropertyExists = (property: IThemePropertiesFromApi) =>
      Object.keys(property).length > 0;
    const shouldDisplayMenuTab = (TabType: string) => {
      const tabType = TabType.toLowerCase();
      if (
        tabType === "sports" &&
        isPropertyExists(getSingleThemeProperty("index_blog_1")) &&
        !getSingleThemeProperty("index_blog_1").IsHidden
      )
        return true;
      if (
        tabType === "virtual sports" &&
        isPropertyExists(getSingleThemeProperty("index_blog_2")) &&
        !getSingleThemeProperty("index_blog_2").IsHidden
      )
        return true;
      if (
        tabType === "live casino" &&
        isPropertyExists(getSingleThemeProperty("index_blog_3")) &&
        !getSingleThemeProperty("index_blog_3").IsHidden
      )
        return true;
      if (
        tabType === "games" &&
        isPropertyExists(getSingleThemeProperty("index_blog_4")) &&
        !getSingleThemeProperty("index_blog_4").IsHidden
      )
        return true;
      if (
        tabType === "cock fight" &&
        isPropertyExists(getSingleThemeProperty("index_blog_5")) &&
        !getSingleThemeProperty("index_blog_5").IsHidden
      )
        return true;
      if (
        tabType === "poker" &&
        isPropertyExists(getSingleThemeProperty("index_blog_6")) &&
        !getSingleThemeProperty("index_blog_6").IsHidden
      )
        return true;
      if (
        tabType === "lottery" &&
        isPropertyExists(getSingleThemeProperty("index_blog_7")) &&
        !getSingleThemeProperty("index_blog_7").IsHidden
      )
        return true;
      if (
        tabType === "keno" &&
        isPropertyExists(getSingleThemeProperty("index_blog_8")) &&
        !getSingleThemeProperty("index_blog_8").IsHidden
      )
        return true;
      if (
        tabType === "promotion" &&
        isPropertyExists(getSingleThemeProperty("index_blog_9")) &&
        !getSingleThemeProperty("index_blog_9").IsHidden
      )
        return true;

      return false;
    };
    const getMenuTabContent = (TabType: string): IThemePropertiesFromApi => {
      const tabType = TabType.toLowerCase();
      if (tabType === "sports") return getSingleThemeProperty("index_blog_1");
      if (tabType === "virtual sports")
        return getSingleThemeProperty("index_blog_2");
      if (tabType === "live casino")
        return getSingleThemeProperty("index_blog_3");
      if (tabType === "games") return getSingleThemeProperty("index_blog_4");
      if (tabType === "cock fight")
        return getSingleThemeProperty("index_blog_5");
      if (tabType === "poker") return getSingleThemeProperty("index_blog_6");
      if (tabType === "lottery") return getSingleThemeProperty("index_blog_7");
      if (tabType === "keno") return getSingleThemeProperty("index_blog_8");
      if (tabType === "promotion")
        return getSingleThemeProperty("index_blog_9");

      return {
        HtmlId: "",
        ThemeId: 0,
        ThemeName: "",
        Type: 0,
        Path: "",
        Height: "",
        Width: "",
        HyperLink: "",
        Text: "",
        ResourceKey: "",
        IsHidden: true,
        IsDefault: false,
        Language: "",
        ImagePath: "",
      };
    };
    const isShowPromotionFullWidth = computed(() => {
      let isBoolean = false;
      if (authenticated.value) {
        isBoolean = !depositWithdrawEnabled.value;
      } else {
        isBoolean = !registerEnabled.value;
      }
      return isBoolean;
    });
    const toggleAuthModal = (): void => {
      store.commit("updateRegisterDialog", true);
    };
    const { isBhinbhin } = commonHelper;
    return {
      isRecommendMatchEnabled,
      menuTabHeaders,
      registerEnabled,
      authenticated,
      depositWithdrawEnabled,
      promotionTabEnabled,
      shouldDisplayMenuTab,
      getMenuTabContent,
      isShowPromotionFullWidth,
      toggleAuthModal,
      themeProperties,
      isCashPlayer,
      isShowDepositWithdrawal,
      announcement,
      isBhinbhin,
    };
  },
});
</script>

<style scoped>
.el-carousel__container {
  height: 125px;
}
</style>
<style lang="scss">
.mobileBannerCarouselBfm1 {
  .el-carousel__indicators {
    .el-carousel__indicator {
      &.is-active .el-carousel__button {
        background: var(--primary);
      }
      .el-carousel__button {
        width: 5px;
        height: 5px;
        border-radius: 2px;
        background: rgba(255, 255, 255, 0.5);
      }
    }
  }
  .el-carousel__container {
    .el-carousel__arrow {
      display: none;
    }
  }
}
.deposit-promotion-container {
  .lobby-quicklink::before {
    content: "";
    position: absolute;
    top: 0.375rem;
    left: 0.375rem;
    width: 0;
    height: 0;
    border: 0.5rem solid;
    border-color: transparent;
    border-top-color: currentColor;
    border-left-color: currentColor;
    opacity: 0.24;
  }
  .lobby-promotion {
    .text {
      fill: none;
      stroke: var(--text);
    }
  }
}
.lobby-list-container > :first-child {
  grid-row-start: 1;
  grid-row-end: 3;
}
.lobby-list-container {
  .lobby-entry {
    position: relative;
    display: flex;
    align-items: flex-end;
    border-radius: 6px;
    overflow: hidden;
    cursor: pointer;
    img {
      position: absolute;
      top: 0;
      bottom: 0;
      left: 0;
      right: 0;
      width: 100%;
      height: auto;
      max-width: none;
      padding-bottom: 15px;
    }
    .lobby-entry-title {
      position: relative;
      width: 100%;
      padding: 0.5rem;
      text-align: center;
      color: var(--text);
      background: var(--background3);
    }
  }
}
</style>
